<?php
defined('_VALID') or die('Restricted Access!');
require $config['BASE_DIR']. '/include/function_video.php';
require $config['BASE_DIR']. '/classes/filter.class.php';

if ( $config['recorder_module'] == '0' ) {
    VRedirect::go($config['BASE_URL']. '/error/page_invalid');
}

$video              = array('title' => '', 'keywords' => '', 'category' => 0, 'paysite' => '',
                            'privacy' => 'public', 'anonymous' => 'no');

if ( isset($_POST['video_title']) ) {
    $filter     = new VFilter();
    $title      = $filter->get('video_title');
    $category   = $filter->get('video_category', 'INTEGER');
    $keywords   = $filter->get('video_keywords');
    $paysite    = $filter->get('video_paysite');
    $privacy    = $filter->get('video_privacy');
    $anonymous  = $filter->get('video_anonymous');

    if ( $title == '' ) {
        $errors[]           = $lang['upload.video_title_empty'];
    } else {
        $video['title'] = $title;
    }

    if ( $keywords == '' ) {
        $errors[]           = $lang['upload.video_tags_empty'];
    } else {
        $keywords           = prepare_string($keywords, false);
        $video['keywords']  = $keywords;
    }

    if ( $category == '0' ) {
        $errors[]           = $lang['global.category_empty'];
    } else {
        $video['category']  = $category;
    }

    $recording_name = $_POST['recording'];
    $snapshot_filename = $config['BASE_DIR'] . "/videowhisper/recorder/snapshots/" . $_POST['stream'] . ".jpg";

    if (  $recording_name == '' ) {
        $errors[]           = $lang['upload.video_file_empty'];
    } else {
        $filename           = $recording_name . ".flv";
        $absolute_filename  = $config['vw_recorder_path'] . $filename;
        $extension          = "flv";
    }

    $video['paysite']       = $paysite;
    $video['privacy']       = ( $privacy == 'private' ) ? 'private' : 'public';
    $video['anonymous']     = ( $anonymous == 'yes' ) ? 'yes' : 'no';
    $uid                    = ( $anonymous == 'yes' ) ? getAnonymousUID() : intval($_SESSION['uid']);

    if ( !$errors ) {
        $sql        = "INSERT INTO video
                       SET UID = " .$uid. ", title = '" .mysql_real_escape_string($title). "',
                           channel = " .$category. ", keyword = '" .mysql_real_escape_string($keywords). "',
                           space = '" .$space. "', addtime = '" .time(). "', adddate = '" .date('Y-m-d'). "', vkey = '" .mt_rand(). "',
                           type = '" .$video['privacy']. "', active = '1'";
        $conn->execute($sql);
        $video_id   = mysql_insert_id();
        $vdoname    = $video_id. '.' .$extension;
        $flvdoname  = $video_id. '.flv';
        $vdo_path   = $config['FLVDO_DIR']. '/' .$vdoname;

      // update flv meta tags
      if ( $config['meta_tool'] == 'flvtool2' ) {
          $cmd = $config['metainject']. ' -Uv ' . $absolute_filename . ' ' . $vdo_path;
      } elseif ( $config['meta_tool'] == 'yamdi' ) {
          $cmd = $config['yamdi']. ' -i ' . $absolute_filename . ' -o ' . $vdo_path;
      } else {
          log_conversion($config['LOG_DIR']. '/' .$vid. '.log', 'Invalid meta tool..must be yamdi or flvtool2');
      }
      exec($cmd, $output);
      log_conversion($config['LOG_DIR']. '/' .$video_id. '.log', implode("\n", $output));

      unlink($absolute_filename);


        if ( !$errors ) {
            extract_video_thumbs($vdo_path, $video_id);
            $duration   = get_video_duration($vdo_path, $video_id);
            $vkey       = substr(md5($video_id),11,20);
            $sql        = "UPDATE video SET duration = '" .mysql_real_escape_string($duration). "', vkey = '" .$vkey. "',
                                            vdoname = '" .mysql_real_escape_string($vdoname). "', flvdoname = '" .mysql_real_escape_string($flvdoname). "'
                           WHERE VID = " .intval($video_id). " LIMIT 1";
            $conn->execute($sql);

            $video_url  = $config['BASE_URL']. '/video/' .$video_id. '/' .prepare_string($title);
			      $video_link = '<a href="'.$video_url.'">'.$video_url.'</a>';

            $sql        = "SELECT sv.SUID, s.username, s.email FROM video_subscribe AS sv, signup AS s
                           WHERE sv.UID = " .$uid. " AND sv.UID = s.UID";
            $rs         = $conn->execute($sql);
            if ( $conn->Affected_Rows() > 0 ) {
                $subscribers    = $rs->getrows();
                $mail           = new VMail();
                $mail->setNoReply();
                $sql            = "SELECT * FROM emailinfo WHERE email_id = 'subscribe_email' LIMIT 1";
                $rs             = $conn->execute($sql);
                $email_path     = $config['BASE_DIR']. '/templates/' .$rs->fields['email_path'];
                $sender         = ( $anonymous == 'yes' ) ? 'anonymous' : $_SESSION['username'];
                $mail->Subject  = str_replace('$sender_name', $sender, $rs->fields['email_subject']);
                foreach ( $subscribers as $subscriber ) {
                    $smarty->assign('video_link', $video_link);
                    $smarty->assign('username', $subscriber['username']);
                    $smarty->assign('sender_name', $_SESSION['username']);
                    $body               = $smarty->fetch($email_path);
                    $mail->AltBody      = $body;
                    $mail->Body         = nl2br($body);
                    $mail->AddAddress($subscriber['email']);
                    $mail->Send();
                    $mail->ClearAddresses();
                }
            }

            $search     = array('{$site_title}', '{$site_name}', '{$username}', '{$video_link}', '{$baseurl}');
            $replace    = array($config['site_title'], $config['site_name'], $_SESSION['username'], $video_link, $config['BASE_URL']);
            $mail       = new VMail();
            if ( $config['approve'] == '0' ) {
                $mail->sendPredefined($_SESSION['email'], 'video_approve', $search, $replace);
            } else {
                $mail->sendPredefined($_SESSION['email'], 'video_upload', $search, $replace);
            }

            $sql        = "UPDATE channel SET total_videos = total_videos+1 WHERE CHID = " .$category. " LIMIT 1";
            $conn->execute($sql);
            $sql        = "UPDATE signup SET total_videos = total_videos+1, points = points+10 WHERE UID = " .$uid. " LIMIT 1";
            $conn->execute($sql);

            $video['title']     = '';
            $video['keywords']  = '';
            $video['category']  = 0;
            $video['paysite']   = '';
            $video['privacy']   = 'public';
            $video['anonymous'] = 'no';

            if ( $config['approve'] == '1' ) {
				$messages[] = translate('upload.video_approve', $config['site_name']);
            } else {
				$messages[] = translate('upload.video_success', $config['site_name'], $video_url, htmlspecialchars($title, ENT_QUOTES, 'UTF-8'));
            }
        }
    }
}

$smarty->assign('video', $video);
$smarty->assign('upload_id', $upload_id);
$smarty->assign('upload_video', true);
$smarty->assign('categories', get_categories());
$smarty->assign('recording', $_GET['recording']);
$smarty->assign('stream', $_GET['stream']);
?>
